' Cellular Automata map creation utility release 5
' (c) Michael Romanovsky 2002-2011 -- camap@flyingsoft.phatcode.net
' If you wish to use this for a freeware program please give due credit.
' Otherwise please give due compensation. :)

#include "fbpng.bi"

declare function askyesnoexit (byval y as integer, byval x as integer, byval varMax as integer) as integer
declare function color2 (byval param as uinteger) as uinteger
declare sub main ()
declare sub speedslower ()
declare sub header ()
declare sub setrandom ()
declare sub sleep2 ()
declare sub loadvars ()
declare sub presetvars ()
declare sub randomoptionParam0 ()
declare sub worldRound ()
declare sub prettyColors ()
declare sub readPrettyColors ()
declare sub saveMap (byval statsTextOffset as uinteger)

dim shared as integer xDrawOffset = 40, yDrawOffset = 40
dim shared xSize as integer, ySize as integer: xSize = 400: ySize = 400
dim shared total as longint
dim shared cell (xSize + 2, ySize + 2) as integer, cell2(xSize + 2, ySize + 2) as integer
dim shared loadedstring (20) as string, optionParam(20) as string
dim shared randerosion (1000) as integer
dim shared as integer randErosionVar1, randErosionVar2, wRound, beachShow, seed, cc
dim shared as integer erosionseed, choice, random1, randratio, randomC, landMassSize, landWaterRatio, erosion, speed
dim shared as integer waterColor, landColor, forestColor
dim shared as integer downUpFlow, leftRightFlow
dim shared as integer downFlowEnabled, upFlowEnabled, leftFlowEnabled, rightFlowEnabled
dim shared as integer rightFlowRatio, upFlowRatio
dim shared as integer oceanEdgeSizeX, oceanEdgeSizey
dim shared as string iString, mapString
dim shared as integer swcolor
dim shared as longint water, land, tvars, tCycles
dim shared as integer maxlength
dim shared as integer x, y, neighbors, varChoice
dim shared as double ratio1, ratio2, ratio3
dim shared filename as string

main ()


sub main ()
 cls
 screenres 800, 600, 32, 1
 width 100, 37
 header ()
 color color2(15): locate 7, 1: print " Use pre-set conditions? (use arrow keys)"
 color color2(1): locate 8, 1: print " (otherwise load conditions)"
 color color2(4)
 optionParam(0) = "no": optionParam(1) = "yes": optionParam(2) = "exit"
 choice = askyesnoexit(7, 43, 3)
 select case choice
 case 0: loadvars
 case 1: presetvars
 case 2: system
 end select

 if random1 = 1 then setrandom
 if randratio = 0 then randratio = int(rnd * 10) + 40
 if randomC = 0 then randomoptionParam0
 cls

 total = xSize * ySize

 ' Main loop starts now.
 do
  swcolor = 1 - swcolor
  worldround
  for x = 1 to xSize
   for y = 1 to ySize
    neighbors = 0
    if cell(x - 1, y - 1) = 3 then neighbors += 1
    if cell(x + 1, y - 1) = 3 then neighbors += 1
    if cell(x - 1, y + 1) = 3 then neighbors += 1
    if cell(x + 1, y + 1) = 3 then neighbors += 1

    if (downUpFlow andalso int(rnd*100) <= downUpFlow) and ((upFlowEnabled <> 0) or (downFlowEnabled <> 0)) then
    if upFlowEnabled = 0 orelse int(rnd*100) <= upFlowRatio then
      if cell(x, y - 1)     = 2 then neighbors += 1
      if cell(x, y + 1)     = 3 then neighbors += 1
     else
      if cell(x, y - 1)     = 3 then neighbors += 1
      if cell(x, y + 1)     = 2 then neighbors += 1
     end if
    else
     if cell(x, y - 1)     = 3 then neighbors += 1
     if cell(x, y + 1)     = 3 then neighbors += 1
    end if

    if (leftRightFlow andalso int(rnd*100) <= leftRightFlow) and ((leftFlowEnabled <> 0) or (rightFlowEnabled <> 0)) then
    if leftFlowEnabled = 0 orelse int(rnd*100) <= rightFlowRatio then
      if cell(x - 1, y)     = 3 then neighbors += 1
      if cell(x + 1, y)     = 2 then neighbors += 1
     else
      if cell(x - 1, y)     = 2 then neighbors += 1
      if cell(x + 1, y)     = 3 then neighbors += 1
     end if
    else
     if cell(x - 1, y)     = 3 then neighbors += 1
     if cell(x + 1, y)     = 3 then neighbors += 1
    end if

    if cell(x, y)         = 0 then
     if neighbors < 4 then cell2(x, y) = 3
    else
     if cell(x, y) = 3 then if neighbors > landMassSize then cell2(x, y) = 0
     if neighbors = landWaterRatio then cell2(x, y) = 0
    end if
   next y
  next x
  tCycles += 1
  if erosion = 1 then landWaterRatio = randerosion(tCycles mod 1000)
  if speed <> 0 then speedslower
  if inkey <> "" then exit do
  prettycolors ()
 loop

 readprettycolors ()
 dim as integer statsTextOffset = 30

 ratio1 = 100 * land / total
 ratio2 = 100 * water / total
 ratio3 = 100 * (total - land - water) / total
 color color2(15)
 locate statsTextOffset, 1: print " Variations ended at: "; str(tvars); " variations.";
 print tCycles; " total cyles."
 locate statsTextOffset + 2, 1: print " Percent color " + str(watercolor) + ": "; str(ratio1); "%"
 locate statsTextOffset + 3, 1: print " Percent color " + str(landcolor) + ": "; str(ratio2); "%"
 locate statsTextOffset + 4, 1: print " Percent color " + str(forestcolor) + ": "; str(ratio3); "%"

 sleep2
 do
  locate statsTextOffset + 5, 1: print string(50, " ")
  locate statsTextOffset + 5, 1: input " Save map to file? ", iString
  iString = lcase$(iString)
  if iString = "y" orelse iString = "yes" then
   saveMap (statsTextOffset)
   exit do
  end if
  if iString = "n" orelse iString = "no" orelse iString = "exit" orelse iString = "quit" then exit do
 loop
 system
end sub


sub worldround ()
 for y = 1 to ySize: cell(0, y) = cell(xSize, y): cell(xSize + 1, y) = cell(1, y): next y
 for x = 1 to xSize: cell(x, 0) = cell(x, ySize): cell(x, ySize + 1) = cell(x, 1): next x
end sub


sub WorldNotRound ()
 for y = 1 to ySize: cell(0, y) = 0: cell(xSize + 1, y) = 0: next y
 for x = 1 to xSize: cell(x, 0) = 0: cell(x, ySize + 1) = 0: next x
end sub


sub randomoptionParam0 ()
 for x = oceanEdgeSizeX to xSize - oceanEdgeSizeX
 for y = oceanEdgeSizey to ySize - oceanEdgeSizey
  cell(x, y) = int(rnd * 2)
 next y, x
end sub


sub randomoptionParam1 ()
 for x = oceanEdgeSizeX to xSize - oceanEdgeSizeX
 for y = oceanEdgeSizey to ySize - oceanEdgeSizey
 if int(rnd * 100) < 50 then cell(x, y) = 0 else cell(x, y) = 3
 next y, x
end sub


sub randomoptionParam2 ()
 for x = oceanEdgeSizeX to xSize - oceanEdgeSizeX
 for y = oceanEdgeSizey to ySize - oceanEdgeSizey
 if int(rnd * 100) > randratio then cell(x, y) = 0 else cell(x, y) = 3
 next y, x
end sub


sub randerosionset ()
 randomize erosionseed
 for i as integer = 1 to 1000: randerosion(i) = int(rnd * randErosionVar1) + randErosionVar2: next i
end sub


sub presetvars ()
 forestcolor = 2: landcolor = 6: watercolor = 1
 oceanEdgeSizeX = 0: oceanEdgeSizey = 0
 wRound = 1: landWaterRatio = 6: landMassSize = 4
 beachShow = 2: erosion = 0
 randErosionVar1 = 3: randErosionVar2 = 2: erosionseed = 0
 random1 = 1: randratio = 0: seed = 0: speed = 0
 downUpFlow = 100
 downFlowEnabled = 1
 upFlowEnabled = 0
 upFlowRatio = 0
 leftRightFlow = 0
 leftFlowEnabled = 1
 rightFlowEnabled = 1
 rightFlowRatio = 0
end sub


sub loadvars ()

 ' Load pre-setvars, just in case.
 presetvars ()
 dim as integer equalSignPosition
 dim as string paramName, paramValueString, curLine
 color color2(15)
 locate 7, 1: print string(50, " "): locate 8, 1: print string(33, " ")
 locate 7, 1: input " Please enter the ini file name to load: ", filename
 if instr(filename, ".ini") = 0 then filename = filename + ".ini"

 open filename for input as #1

 do
  input #1, curLine
  equalSignPosition = instr(curLine, "=")
  paramValueString = lcase(trim(mid(curLine, equalSignPosition + 1)))
  paramName = lcase(trim(mid(curLine, 1, equalSignPosition-1)))
  select case paramName
  case "landcolor"        : landcolor = valint(paramValueString)
  case "watercolor"       : watercolor = valint(paramValueString)
  case "forestcolor"      : forestcolor = valint(paramValueString)
  case "xsize"            : xSize = valint(paramValueString)
  case "ysize"            : ySize = valint(paramValueString)
  case "oceanedgesizex"   : oceanEdgeSizeX = valint(paramValueString)
  case "oceanedgesizey"   : oceanEdgeSizeY = valint(paramValueString)
  case "wround"           : wRound = valint(paramValueString)
  case "landwaterratio"   : landWaterRatio = valint(paramValueString)
  case "landmasssize"     : landMassSize = valint(paramValueString)
  case "beachshow"        : beachShow = valint(paramValueString)
  case "erosion"          : erosion = valint(paramValueString)
  case "randerosionvar1"  : randErosionVar1 = valint(paramValueString)
  case "randerosionvar2"  : randErosionVar2 = valint(paramValueString)
  case "erosionseed"      : erosionSeed = valint(paramValueString)
  case "random1"          : random1 = valint(paramValueString)
  case "randratio"        : randRatio = valint(paramValueString)
  case "seed"             : seed = valint(paramValueString)
  case "speed"            : speed = valint(paramValueString)
  case "downupflow"       : downUpFlow = valint(paramValueString)
  case "downflowenabled"  : downFlowEnabled = valint(paramValueString)
  case "upflowenabled"    : upFlowEnabled = valint(paramValueString)
  case "upflowratio"      : upFlowRatio = valint(paramValueString)
  case "leftrightflow"    : leftRightFlow = valint(paramValueString)
  case "leftflowenabled"  : leftFlowEnabled= valint(paramValueString)
  case "rightflowenabled" : rightFlowEnabled  = valint(paramValueString)
  case "rightflowratio"   : rightFlowRatio = valint(paramValueString)
  end select
  if eof(1) then exit do
 loop
 close #1
 print " Settings loaded.": sleep2
end sub


sub saveMap (byval statsTextOffset as uinteger)
 color color2(15)
 locate statsTextOffset + 5, 1: print string(50, " ")
 locate statsTextOffset + 5, 1: input " File name to save as? ", filename
 if instr(filename, ".png") = 0 then filename = filename + ".png"
 dim curImg as any ptr = imageCreate (xSize, ySize, rgb(0,255,255), 32)
 get (xDrawOffset, yDrawOffset) - (xDrawOffset + xSize - 1, yDrawOffset + ySize - 1), curImg
 png_save (filename, curImg)
 imageDestroy  (curImg)
 sleep2
end sub


sub prettycolors ()
 for x = 1 to xSize
  for y = 1 to ySize
   if cell(x, y) <> cell2(x, y) then
    cell(x, y) = cell2(x, y)
    cc = cell2(x, y)
    if swcolor = 0 then if cc = 3 then cc = 0 else cc = 3
    if cc = 0 then cc = watercolor else cc = landcolor
   else
    cc = forestcolor
   end if
   pset (x + xDrawOffset, y + yDrawOffset), color2(cc)
  next y
 next x
end sub


sub readprettycolors ()
 for x = 1 to xSize
  for y = 1 to ySize
   if cell(x, y) <> cell2(x, y) then
    cc = cell2(x, y)
    if swcolor = 0 then if cc = 3 then cc = 0 else cc = 3
    if cc = 0 then cc = watercolor: land = land + 1 else cc = landcolor: water = water + 1
    else tvars = tvars + 1: cc = forestcolor
   end if
   cell(x, y) = cc
  next y
 next x
end sub


function askyesnoexit (byval y as integer, byval x as integer, byval varMax as integer) as integer
 varMax = varMax - 1
 varChoice = 0
 for i as integer = 0 to varMax
  if len(optionParam(i)) > maxlength then maxlength = len(optionParam(i))
 next i

 locate y, x: print optionParam(varChoice) + space(maxlength - len(optionParam(varChoice)))
 do
  do
   iString = inkey
   if iString <> "" then exit do
  loop
  select case iString
  case chr(255) + "M" : varChoice = varChoice + 1
  case chr(255) + "K" : varChoice = varChoice - 1
  case chr(255) + "H" : varChoice = varChoice + 1
  case chr(255) + "P" : varChoice = varChoice - 1
  case chr(13)        : exit do
  end select
  if varChoice < 0 then varChoice = varMax
  if varChoice > varMax then varChoice = 0
  locate y, x: print optionParam(varChoice) + space(maxlength - len(optionParam(varChoice)))
 loop
 askyesnoexit = varChoice
end function


sub header
 color color2(4)
 print "            Cellular Automata Map Creation Utility release 5"
 color color2(1)
 print
 print "              (C) 2011 Agamemnus (Michael Romanovsky)"
 print "                 (Member of "; : color color2(9): print "Flyingsoft"; : color color2(1): print " Programming Group)"
end sub


sub setrandom
 dim rndSeedString as string
 dim rndSeed as uinteger
 color color2(15)
 do
  locate 7, 1: print string(80, " ")
  locate 8, 1: print string(80, " ")
  locate 7, 1: input " Give me a random number seed! (0 = random number) ", rndSeedString
  rndSeedString = lcase$(rndSeedString)
  if rndSeedString <> "no" then exit do
  locate 8, 1: print " Don't be a fool!": sleep2
 loop
 rndSeed = val(rndSeedString)
 if rndSeed = 0 then randomize timer
 locate 23, 1: print " <press any key to continue>"
 sleep2
end sub


sub sleep2
 do
  if inkey <> "" then exit do
 loop
end sub


sub speedslower
 for i as integer = 1 to 1000
  for i2 as integer = 1 to speed
  next i2
 next i
end sub

function color2 (byval param as uinteger) as uinteger
 select case param
 case 0  : return rgb(0, 0, 0)
 case 1  : return rgb(0, 0, 170)
 case 2  : return rgb(0, 170, 0)
 case 3  : return rgb(0, 170, 170)
 case 4  : return rgb(170, 0, 0)
 case 5  : return rgb(170, 0, 170)
 case 6  : return rgb(170, 85, 0)
 case 7  : return rgb(170, 170, 170)
 case 8  : return rgb(85, 85, 85)
 case 9  : return rgb(85, 85, 255)
 case 10 : return rgb(85, 255, 85)
 case 11 : return rgb(85, 255, 255)
 case 12 : return rgb(255, 85, 85)
 case 13 : return rgb(255, 85, 255)
 case 14 : return rgb(255, 255, 85)
 case 15 : return rgb(255, 255, 255)
 end select
end function
